# AllSQL - An open-source compact browser based SQL Compiler

![style: lint](https://img.shields.io/badge/style-lint-4BC0F5.svg)
![repo size](https://img.shields.io/github/repo-size/masteradit/AllSQL)
![issues open](https://img.shields.io/github/issues/masteradit/AllSQL)
![pull requests open](https://img.shields.io/github/issues-pr/masteradit/AllSQL)
![license: MIT](https://img.shields.io/github/license/masteradit/AllSQL)
![latest version](https://img.shields.io/github/v/release/masteradit/AllSQL)
[![Netlify Status](https://api.netlify.com/api/v1/badges/31d231ee-72ca-4f9a-84d1-7e73ef4851c1/deploy-status)](https://sql.allmityapp.com)
![contributors](https://img.shields.io/github/contributors/masteradit/AllSQL)
![watchers](https://badgen.net/github/watchers/masteradit/AllSQL)
![stars](https://badgen.net/github/stars/masteradit/AllSQL)
![forks](https://badgen.net/github/forks/masteradit/AllSQL)
<!-- ![languages](https://img.shields.io/github/languages/count/masteradit/AllSQL) -->
<!-- ![top language percentage](https://img.shields.io/github/languages/top/masteradit/AllSQL) -->
<!-- ![code size](https://img.shields.io/github/languages/code-size/masteradit/AllSQL) -->
<!-- ![issues closed](https://img.shields.io/github/issues-closed/masteradit/AllSQL) -->
<!-- ![pull requests closed](https://img.shields.io/github/issues-pr-closed/masteradit/AllSQL) -->
<!-- ![commit activity](https://img.shields.io/github/commit-activity/m/masteradit/AllSQL) -->
<!-- ![last commit](https://img.shields.io/github/last-commit/masteradit/AllSQL) -->

AllSQL is an open-source compact browser based SQL Compiler, built using Flutter. Please create an issue on GitHub if you find a bug or have a feature request. Feel free to create pull requests if you are interested in contributing to this project.

## ✨ Demo

Website: https://sql.allmityapp.com

![Demo GIF](https://github.com/masteradit/AllSQL/raw/master/images/recording.gif)

*Please ignore the mouse in the gif above. The screen recording software glitched the mouse position.*

## ⚡ Features

- ✅ Server is not required
- ✅ Output is neatly formatted in the form of a table
- ✅ Helper text to explain the use of each option with example
- ✅ Very small size (< 6 MB)
- ✅ Works on web
- ✅ Can be installed as a Progressive Web App on Android, iOS, Windows, MacOS and Linux
- ✅ Works offline

## 🐛 Known issues/bugs

- ❗ Make AllSQL responsive on smaller screens
- ❗ Show error message when an exception is thrown
- ❗ Automatically execute commands instead of selecting the type of command manually
- ❗ Show multiple tables in output if multiple select queries are entered
- ❗ Add dark theme
- ❗ Add syntax highlighting

## 🤔 Why did I make AllSQL?

I have a Database Systems course in college. Our teacher recommended us to download Oracle Database 19c, which is around 2.7 GB in size. Some of my friends faced issues while installing the software. So, I wanted to make a ligh weight, compact, browser based compiler, where anyone could practice SQL commands, on any device without installing a heavy software.

## 👏 Getting Started

This project is a starting point for a Flutter application.

A few resources to get you started if this is your first Flutter project:

- [Lab: Write your first Flutter app](https://flutter.dev/docs/get-started/codelab)
- [Cookbook: Useful Flutter samples](https://flutter.dev/docs/cookbook)

For help getting started with Flutter, view our
[online documentation](https://flutter.dev/docs), which offers tutorials,
samples, guidance on mobile development, and a full API reference.

## 📚 Documentation

- Website: https://docs.sql.allmityapp.com/
- GitHub repository: https://github.com/masteradit/AllSQL-Docs

## 🙏 Show your support

Please ⭐️ this repository if this project helped you!

<a href="https://www.buymeacoffee.com/aditluhadia" target="blank"><img src="https://github.com/masteradit/AllSQL/raw/master/images/bmc-button.png" alt="Buy me a coffee" height="45" /></a>

## 👥 Contributors

<a href="https://github.com/masteradit/AllSQL/graphs/contributors">
  <img src="https://contrib.rocks/image?repo=masteradit/AllSQL" />
</a>

Made with [contributors-img](https://contrib.rocks).

<!-- ## Contributors over time

![Contributors over time](https://contributor-graph-api.apiseven.com/contributors-svg?chart=contributorOverTime&repo=masteradit/AllSQL) -->

## Stargazers over time

[![Stargazers over time](https://starchart.cc/masteradit/AllSQL.svg)](https://starchart.cc/masteradit/AllSQL)

## 📝 License

Copyright © 2021 [Adit Luhadia](https://github.com/masteradit).

This project is [MIT](https://github.com/masteradit/AllSQL/blob/master/LICENSE) licensed.
